const {
  Plugin,
  Command,
} = require( 'neovim/plugin');
const beautify = require('cssbeautify');

class Demo {
  async beautify() {
    try {
      const buffer = await this.nvim.getCurrentBuffer();
      console.log(buffer);
      const lines = await buffer.getLineSlice(0, -1, true, true);
      const beautified = beautify(lines.join('\n'));
      return buffer.setLineSlice(0, -1, true, true, beautified.split('\n'));
    } catch (err) {
      console.error(err);
    }
  }
}

Command('BeautifyCSS', { sync: true })(
  Demo.prototype, 'beautify'
);

module.exports = Plugin({ dev: true })(
  Demo
);

console.log('demo', Demo, Demo.prototype, Demo._nvim_plugin);
module.exports.default = module.exports;
