// eslint-ignore-rule no-console
const cp = require('child_process');

const attach = require('../attach');
const inspect = require('util').inspect;

const proc = cp.spawn('nvim', ['-u', 'NONE', '-N', '--embed'], {
  cwd: __dirname
});

// const net = require('net');

// const client = net.createConnection({ path: '/tmp/nvim' }, () => {
  // console.log('connected to nvim socket');
  // client.on('end', () => {
    // console.log('disconnected from server');
  // });
// });
// client.on('data', data => {
  // console.log(data.toString());
// });
// client.on('end', () => {
  // console.log('disconnected from server');
// });

async function main() {
  const nvim = await attach({ proc });
  // const nvim = await attach({ socket: '/tmp/nvim' });
  nvim.on('request', (method, args, resp) => {
    // handle msgpack-rpc request
    console.log('request', method, args, resp);
  });

  nvim.on('notification', (method, args) => {
    // handle msgpack-rpc notification
    console.log('notification', method, args);
  });

  await nvim.apiPromise;

  await nvim.command('vsp');
  const windows = await nvim.listWins();

  console.log(windows.length);

  nvim.setCurrentWin(windows[1]);
  const win = await nvim.getCurrentWin();
  console.log(win._data, windows[1]._data);

  const buf = await nvim.getCurrentBuf();
  console.log(buf instanceof nvim.Buffer);

  const lines = await buf.getLines(0, -1, true);
  console.log(lines);

  await buf.setLines(0, -1, true, ['line1', 'line2']);
  const newLines = await buf.getLines(0, -1, true);
  console.log(newLines);
}

try {
  main();
} catch (err) {
  console.error(err);
  process.exit(1);
}
process.on('unhandledRejection', (reason, p) => {
  console.log('Unhandled Rejection at:', p, 'reason:', reason);
  process.exit(1);
  // application specific logging, throwing an error, or other logic here
});
